package com.fr.decision.auth.http.config;

import com.fanruan.api.conf.BaseConfiguration;
import com.fanruan.api.conf.HolderKit;
import com.fr.config.Identifier;
import com.fr.config.Status;
import com.fr.config.Visualization;
import com.fr.config.holder.Conf;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/9/20
 */
@Visualization(category = "Plugin-Http_Config_Group")
public class HttpAuthorizeConfig extends BaseConfiguration {

    private static volatile HttpAuthorizeConfig instance;

    public static HttpAuthorizeConfig getInstance() {
        if (instance == null) {
            instance = getConfigInstance(HttpAuthorizeConfig.class);
        }
        return instance;
    }

    @Identifier(value = "condition", name = "Plugin-Http_Config_Property_Text", description = "Plugin-Http_Config_Property_Text_Description", status = Status.SHOW)
    private Conf<String> condition = HolderKit.simple("value != \"false\"");

    public String getCondition() {
        return condition.get();
    }

    public void setCondition(String condition) {
        this.condition.set(condition);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        HttpAuthorizeConfig cloned = (HttpAuthorizeConfig) super.clone();
        cloned.condition = (Conf<String>) condition.clone();
        return cloned;
    }
}
